#ifndef BisqPAPU_h
#define BisqPAPU_h

#include "papu_internals.hh"
#include "papu_squareunit.hh"
#include "papu_triangleunit.hh"
#include "papu_randgenunit.hh"
#include "papu_dmcgenunit.hh"

class sq1gen : public squaregenunit { public: sq1gen() { set_decr_mode(0); } };
class sq2gen : public squaregenunit { public: sq2gen() { set_decr_mode(1); } };

class bisqpapu
{
    int Rate;
    
    sq1gen chan1;
    sq2gen chan2;
    triangleunit chan3;
    rndgen chan4;
    dmcgen chan5;
    
    unsigned long counter, speed;
    
    void mixbytes(unsigned count);
    
private:
    unsigned countermax, hzcounter;
    fBYTE hzpos;
    
    void hzticks();
    void hz60ticks();
    void hz120ticks();
    void hz240ticks();
public:
    bisqpapu();
    ~bisqpapu();
    
    bool write(const fWORD addr, fBYTE value);
    bool read(const fWORD addr, BYTE &value);
    
    bool tick();
    
    void debug_silence()
    {
    	fprintf(stderr, "\33[1;36mpAPU channels:\n");
    	fprintf(stderr, " 1: "); chan1.debug_silence(); fprintf(stderr, "\n");
    	fprintf(stderr, " 2: "); chan2.debug_silence(); fprintf(stderr, "\n");
    	fprintf(stderr, " 3: "); chan3.debug_silence(); fprintf(stderr, "\n");
    	fprintf(stderr, " 4: "); chan4.debug_silence(); fprintf(stderr, "\n");
    	fprintf(stderr, " 5: "); chan5.debug_silence(); fprintf(stderr, "\n");
		fprintf(stderr, "\33[m\n");
    }
};

#endif
