#include "papu_internals.hh"
#include "papu_lengthunit.hh"

void lengthunit::write(fBYTE ind, fBYTE value)
{
    if(ind == 3)
    {
        static const BYTE lengthtrans[32]=
        {5,127,10,1,20, 2,40, 3,80, 4,30, 5,7, 6,14, 7,
         6,  8,12,9,24,10,48,11,96,12,36,13,8,14,16,15};

        // Ks papu.txt jos tuon taulukon sislt kiinnostaa
        
        if(chanenabled)
        {
            lengthcounter = lengthtrans[(value >> 3) & 31];
            #if PAPU_LENGTH_DEBUG
            fprintf(stderr, "(\33[1;33mlcounter=%u\33[m)", lengthcounter);
            #endif
        }
        else
        {
            #if PAPU_LENGTH_DEBUG
        	fprintf(stderr, "(\33[1;31mlcounter NOT MODIFIED\33[m)");
        	#endif
        }
    }
    if(ind == 0)
    {
        lengthdisabled = (value & bmask);
        #if PAPU_LENGTH_DEBUG
        if(lengthdisabled)
        	fprintf(stderr, "(\33[33mlength DISabled at %u\33[m)", lengthcounter);
        else
        	fprintf(stderr, "(\33[33mlength ENabled at %u\33[m)", lengthcounter);
        #endif
    }
}

BEGIN_HZTICKER(60, lengthunit)
    if(!lengthdisabled && lengthcounter > 0)
        --lengthcounter;
END_HZTICKER
